# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.CalculateScore200Response do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :categoryScores,
    :inferenceScores,
    :mediaCountScores,
    :categoryPhotosPresent,
    :finalCategoryScores,
    :bonusScore,
    :finalScore,
    :reportHasRequiredInformation
  ]

  @type t :: %__MODULE__{
    :categoryScores => FoyerAPI.Model.PropertyScoreCategoryScores.t | nil,
    :inferenceScores => FoyerAPI.Model.PropertyScoreInferenceScores.t | nil,
    :mediaCountScores => FoyerAPI.Model.PropertyScoreMediaCountScores.t | nil,
    :categoryPhotosPresent => FoyerAPI.Model.PropertyScoreCategoryPhotosPresent.t | nil,
    :finalCategoryScores => FoyerAPI.Model.PropertyScoreFinalCategoryScores.t | nil,
    :bonusScore => FoyerAPI.Model.Score.t | nil,
    :finalScore => float() | nil,
    :reportHasRequiredInformation => boolean() | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.CalculateScore200Response do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:categoryScores, :struct, FoyerAPI.Model.PropertyScoreCategoryScores, options)
    |> deserialize(:inferenceScores, :struct, FoyerAPI.Model.PropertyScoreInferenceScores, options)
    |> deserialize(:mediaCountScores, :struct, FoyerAPI.Model.PropertyScoreMediaCountScores, options)
    |> deserialize(:categoryPhotosPresent, :struct, FoyerAPI.Model.PropertyScoreCategoryPhotosPresent, options)
    |> deserialize(:finalCategoryScores, :struct, FoyerAPI.Model.PropertyScoreFinalCategoryScores, options)
    |> deserialize(:bonusScore, :struct, FoyerAPI.Model.Score, options)
  end
end

